pcl::registration::ELCH< PointT > Class Template Reference
Module registration

ELCH (Explicit Loop Closing Heuristic) class More...

`#include <pcl/registration/elch.h>`

Inheritance diagram for pcl::registration::ELCH< PointT >:

## Classes

struct | Vertex

## Public Types

typedef boost::shared_ptr< ELCH< PointT > > | Ptr
typedef boost::shared_ptr< const ELCH< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::adjacency_list< boost::listS, boost::eigen_vecS, boost::undirectedS, Vertex, boost::no_property > | LoopGraph
| graph structure to hold the SLAM graph More...
typedef boost::shared_ptr< LoopGraph > | LoopGraphPtr
typedef pcl::Registration< PointT, PointT > | Registration
typedef Registration::Ptr | RegistrationPtr
typedef Registration::ConstPtr | RegistrationConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ELCH ()
| Empty constructor. More...
virtual | ~ELCH ()
| Empty destructor. More...
void | addPointCloud (PointCloudPtr cloud)
| Add a new point cloud to the internal graph. More...
LoopGraphPtr | getLoopGraph ()
| Getter for the internal graph. More...
void | setLoopGraph (LoopGraphPtr loop_graph)
| Setter for a new internal graph. More...
boost::graph_traits< LoopGraph >::vertex_descriptor | getLoopStart ()
| Getter for the first scan of a loop. More...
void | setLoopStart (const typename boost::graph_traits< LoopGraph >::vertex_descriptor &loop_start)
| Setter for the first scan of a loop. More...
boost::graph_traits< LoopGraph >::vertex_descriptor | getLoopEnd ()
| Getter for the last scan of a loop. More...
void | setLoopEnd (const typename boost::graph_traits< LoopGraph >::vertex_descriptor &loop_end)
| Setter for the last scan of a loop. More...
RegistrationPtr | getReg ()
| Getter for the registration algorithm. More...
void | setReg (RegistrationPtr reg)
| Setter for the registration algorithm. More...
Eigen::Matrix4f | getLoopTransform ()
| Getter for the transformation between the first and the last scan. More...
void | setLoopTransform (const Eigen::Matrix4f &loop_transform)
| Setter for the transformation between the first and the last scan. More...
void | compute ()
| Computes new poses for all point clouds by closing the loop between start and end point cloud. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::registration::ELCH< PointT >

ELCH (Explicit Loop Closing Heuristic) class

Author
  Jochen Sprickerhof

Definition at line 62 of file elch.h.

## Member Typedef Documentation

template<typename PointT >

typedef boost::shared_ptr< const ELCH<PointT> > pcl::registration::ELCH< PointT >::ConstPtr

Definition at line 66 of file elch.h.

template<typename PointT >

typedef boost::adjacency_list< boost::listS, boost::eigen_vecS, boost::undirectedS, Vertex, boost::no_property> pcl::registration::ELCH< PointT >::LoopGraph

graph structure to hold the SLAM graph

Definition at line 84 of file elch.h.

template<typename PointT >

typedef boost::shared_ptr< LoopGraph > pcl::registration::ELCH< PointT >::LoopGraphPtr

Definition at line 86 of file elch.h.

template<typename PointT >

typedef pcl::PointCloud<PointT> pcl::registration::ELCH< PointT >::PointCloud

Definition at line 68 of file elch.h.

template<typename PointT >

typedef PointCloud::ConstPtr pcl::registration::ELCH< PointT >::PointCloudConstPtr

Definition at line 70 of file elch.h.

template<typename PointT >

typedef PointCloud::Ptr pcl::registration::ELCH< PointT >::PointCloudPtr

Definition at line 69 of file elch.h.

template<typename PointT >

typedef boost::shared_ptr< ELCH<PointT> > pcl::registration::ELCH< PointT >::Ptr

Definition at line 65 of file elch.h.

template<typename PointT >

typedef pcl::Registration<PointT, PointT> pcl::registration::ELCH< PointT >::Registration

Definition at line 88 of file elch.h.

template<typename PointT >

typedef Registration::ConstPtr pcl::registration::ELCH< PointT >::RegistrationConstPtr

Definition at line 90 of file elch.h.

template<typename PointT >

typedef Registration::Ptr pcl::registration::ELCH< PointT >::RegistrationPtr

Definition at line 89 of file elch.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::registration::ELCH< PointT >::ELCH | ( |  | ) |

inline

Empty constructor.

Definition at line 93 of file elch.h.

template<typename PointT >

virtual pcl::registration::ELCH< PointT >::~ELCH | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 104 of file elch.h.

## Member Function Documentation

template<typename PointT >

void pcl::registration::ELCH< PointT >::addPointCloud | ( | PointCloudPtr | cloud | ) |

inline

Add a new point cloud to the internal graph.

Parameters

  [in] | cloud | the new point cloud

Definition at line 110 of file elch.h.

References pcl::registration::ELCH< PointT >::Vertex::cloud.

template<typename PointT >

void pcl::registration::ELCH< PointT >::compute | ( |  | ) |

Computes new poses for all point clouds by closing the loop between start and end point cloud.

This will transform all given point clouds for now!

Definition at line 218 of file elch.hpp.

References pcl::transformPointCloud().

Referenced by pcl::registration::ELCH< PointT >::setLoopTransform().

template<typename PointT >

boost::graph_traits<LoopGraph>::vertex_descriptor pcl::registration::ELCH< PointT >::getLoopEnd | ( |  | ) |

inline

Getter for the last scan of a loop.

Definition at line 153 of file elch.h.

template<typename PointT >

LoopGraphPtr pcl::registration::ELCH< PointT >::getLoopGraph | ( |  | ) |

inline

Getter for the internal graph.

Definition at line 121 of file elch.h.

template<typename PointT >

boost::graph_traits<LoopGraph>::vertex_descriptor pcl::registration::ELCH< PointT >::getLoopStart | ( |  | ) |

inline

Getter for the first scan of a loop.

Definition at line 137 of file elch.h.

template<typename PointT >

Eigen::Matrix4f pcl::registration::ELCH< PointT >::getLoopTransform | ( |  | ) |

inline

Getter for the transformation between the first and the last scan.

Definition at line 185 of file elch.h.

template<typename PointT >

RegistrationPtr pcl::registration::ELCH< PointT >::getReg | ( |  | ) |

inline

Getter for the registration algorithm.

Definition at line 169 of file elch.h.

template<typename PointT >

bool pcl::registration::ELCH< PointT >::initCompute | ( |  | ) |

protected virtual

This method should get called before starting the actual computation.

Definition at line 158 of file elch.hpp.

Referenced by pcl::registration::ELCH< PointT >::setLoopTransform().

template<typename PointT >

void pcl::registration::ELCH< PointT >::setLoopEnd | ( | const typename boost::graph_traits< LoopGraph >::vertex_descriptor & | loop_end | ) |

inline

Setter for the last scan of a loop.

Parameters

  [in] | loop_end | the scan that ends the loop

Definition at line 162 of file elch.h.

template<typename PointT >

void pcl::registration::ELCH< PointT >::setLoopGraph | ( | LoopGraphPtr | loop_graph | ) |

inline

Setter for a new internal graph.

Parameters

  [in] | loop_graph | the new graph

Definition at line 130 of file elch.h.

template<typename PointT >

void pcl::registration::ELCH< PointT >::setLoopStart | ( | const typename boost::graph_traits< LoopGraph >::vertex_descriptor & | loop_start | ) |

inline

Setter for the first scan of a loop.

Parameters

  [in] | loop_start | the scan that starts the loop

Definition at line 146 of file elch.h.

template<typename PointT >

void pcl::registration::ELCH< PointT >::setLoopTransform | ( | const Eigen::Matrix4f & | loop_transform | ) |

inline

Setter for the transformation between the first and the last scan.

Parameters

  [in] | loop_transform | the transformation between the first and the last scan

Definition at line 194 of file elch.h.

References pcl::registration::ELCH< PointT >::compute(), and pcl::registration::ELCH< PointT >::initCompute().

template<typename PointT >

void pcl::registration::ELCH< PointT >::setReg | ( | RegistrationPtr | reg | ) |

inline

Setter for the registration algorithm.

Parameters

  [in] | reg | the registration algorithm used to compute the transformation between the start and the end of the loop

Definition at line 178 of file elch.h.

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/registration/include/pcl/registration/elch.h
- /build/pcl-6_P28C/pcl-1.7.2/registration/include/pcl/registration/impl/elch.hpp